// not for sale, rent, auction, nor lease
//+------------------------------------------------------------------------------------------------------------------+
#property description                                                                        "[!!!-MT4 X-XARDg-HMA-1]"
#define Version                                                                                        "[XARDg-HMA-1]"
//+------------------------------------------------------------------------------------------------------------------+
#property link        "https://forex-station.com/viewtopic.php?p=1295409935#p1295409935"
#property description "THIS IS A FREE INDICATOR"
#property description "                                                      "
#property description "Welcome to the World of Forex"
#property description "Let light shine out of darkness and illuminate your world"
#property description "and with this freedom leave behind your cave of denial"
#property strict
#property description "\n\nHull Moving Averages.\n"
#property indicator_chart_window 
#property indicator_buffers 3 
//+------------------------------------------------------------------------------------------------------------------+
   input int period=35;              
   input ENUM_MA_METHOD method=MODE_LWMA;
   input ENUM_APPLIED_PRICE price=PRICE_CLOSE; 

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_LOWER; // chart btn_corner for anchoring
extern string             btn_text              = "HMA35";
extern string             btn_Font              = "Impact";
extern int                btn_FontSize          = 14;                             //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = C'120,120,120';
extern color              btn_background_color  = clrDarkRed;
extern color              btn_border_color      = clrDarkRed;
extern int                button_x              = 676;                                     //btn__x
extern int                button_y              = 25;                                     //btn__y
extern int                btn_Width             = 86;                                 //btn__width
extern int                btn_Height            = 26;                                //btn__height
extern string             UniqueButtonID        = "xard777HMA35_1";
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
   double BGD[],Uptrend[],Dntrend[],ExtMapBuffer[];
//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
string buttonId;

int init()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

// put init() here
   IndicatorBuffers(4); IndicatorShortName("HMA("+IntegerToString(period)+")");
   SetIndexBuffer(0,BGD);          SetIndexStyle(0,DRAW_LINE,0,10,C'100,150,180');
   SetIndexBuffer(1,Uptrend);      SetIndexStyle(1,DRAW_LINE,0,6,clrBlue);
   SetIndexBuffer(2,Dntrend);      SetIndexStyle(2,DRAW_LINE,0,6,clrRed);
   SetIndexBuffer(3,ExtMapBuffer);
   ArraySetAsSeries(ExtMapBuffer,true); 
   
   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + UniqueButtonID;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   
   return 0;
}
//+------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   return 0;
}
//+------------------------------------------------------------------+
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
   double WMA(int x,int p){return(iMA(NULL, 0, p, 0, method, price, x));}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;

int counted_bars=IndicatorCounted(); if(counted_bars<0) return(-1); int x = 0;
   int p = (int)MathSqrt(period); int e = Bars - counted_bars + period + 1; double vect[],trend[];
//+------------------------------------------------------------------------------------------------------------------+
   if(e>Bars) e=Bars;
   ArrayResize(vect,e);  ArraySetAsSeries(vect,true);
   ArrayResize(trend,e); ArraySetAsSeries(trend,true);
   for(x=0; x<e; x++){vect[x]=2*WMA(x,period/2)-WMA(x,period);}
   for(x=0; x<e-period; x++) ExtMapBuffer[x]=iMAOnArray(vect,0,p,0,method,x);
   for(x=e-period; x>=0; x--){ 
  
       trend[x]=trend[x+1];
       if(ExtMapBuffer[x]> ExtMapBuffer[x+1]) trend[x] = 1;
       if(ExtMapBuffer[x]< ExtMapBuffer[x+1]) trend[x] =-1; BGD[x]=ExtMapBuffer[x];
       if(trend[x]>0){Uptrend[x]=ExtMapBuffer[x];
       if(trend[x+1]<0) Uptrend[x+1]=ExtMapBuffer[x+1]; Dntrend[x]=EMPTY_VALUE;} else
       if(trend[x]<0){ Dntrend[x]=ExtMapBuffer[x];
       if(trend[x+1]>0) Dntrend[x+1]=ExtMapBuffer[x+1]; Uptrend[x]=EMPTY_VALUE;}
   
         if (show_data)
      {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
         SetIndexStyle(0,DRAW_LINE,0,10,C'100,150,180');
         SetIndexStyle(1,DRAW_LINE,0,6,clrBlue);
         SetIndexStyle(2,DRAW_LINE,0,6,clrRed);
      }
      else
      {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
         SetIndexStyle(0,DRAW_NONE);
         SetIndexStyle(1,DRAW_NONE);
         SetIndexStyle(2,DRAW_NONE);
       }
} //for(x=e-period; x>=0; x--)
      
   return 0;
}
//+------------------------------------------------------------------+

