// not for sale, rent, auction, nor lease
#property copyright "YouFOREX Brasil"
#property indicator_chart_window
//#property strict

extern string __________GRID1__________ = "<<<<< GRID OPTION 1 >>>>>";
extern bool               Grid1 = True;
extern int                HLine1_2 = 100;
extern int                HLine2_2 = 90;
extern int                HLine3_2 = 80;
extern int                HLine4_2 = 70;
extern int                HLine5_2 = 60;
extern int                HLine6_2 = 50;
extern int                HLine7_2 = 40;
extern int                HLine8_2 = 30;
extern int                HLine9_2 = 20;
extern int                HLine10_2= 10;
extern int                HLine11_2= 0;

extern string __________GRID2__________ = "<<<<< GRID OPTION 2 >>>>>";
extern bool               Grid2 = FALSE;
extern int                HLine1 = 100;
extern int                HLine2 = 75;
extern int                HLine3 = 50;
extern int                HLine4 = 25;
extern int                HLine5 = 0;

extern string __________Grid_1_LINES__________ = "<<<<< Grid 1 LINE PARAMETERS >>>>>";
int                       LineStartIndex        = 20;                // Line Start Index
extern color              Line_Color_1          = clrBlack;          // Grid 1 line color
extern ENUM_LINE_STYLE    Line_Style_1          = STYLE_SOLID;       // Line Style
extern int                Line_Width_1            = 1;               // Line Width
extern string __________Grid_2_LINES__________ = "<<<<< Grid 2 LINE PARAMETERS >>>>>";
extern color              Line_Color            = clrDimGray;        // Line color other
extern color              Line_MedianColor      = clrMidnightBlue;   // Line color median
extern color              Line_Color00          = clrBlack;          // Line color extremes
extern ENUM_LINE_STYLE    Line_Style            = STYLE_DOT;         // Line Style
extern int                Line_Width            = 1;                 // Line Width

extern string __________TEXTS__________        = "<<<<< TEXT LABELS >>>>>";
extern bool               Show_Texts            = TRUE;           // Show Texts?
extern int                Text_Shift            = -10;            // Text Shift
extern color              Text_Color            = Gray;           // Text Color other
extern color              Text_MedianColor      = MidnightBlue;   // Text color median
extern color              Text_Color00          = Black;          // Text Color extremes
extern int                Text_Size             = 10;             // Text Size
extern string             FontType              = "Arial";        // Text Font

//template code start1
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_RIGHT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "PsyLevel";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                  //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrWhite;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 200;                //btn__x
extern int                button_y              = 418;                //btn__y
extern int                btn_Width             = 94;                 //btn__width
extern int                btn_Height            = 20;                 //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1

double Ndigits;
int    Ndecimais;
int    gridd[22];
int    gridx;
int    gridy;
double gridz;
double gridt;
//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
string buttonId;

int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "PsyLevels2020";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
   init2();
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here
   deinit2();
	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   //put start () here
   
      if (show_data)
         {
           ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
           start2();
         }
      else
         {
           ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
           deinit2();
         }
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
int init2() 
{ 
   LineStartIndex = 20;
   Text_Shift     = -20;
   
   if (Digits >= 4) 
   {
      Ndigits = 0.0001;
      Ndecimais = 4;
   } 
   else 
   {
      Ndigits = 0.01;
      Ndecimais = 2;
   }
   cleanup();
   return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit2() 
{
   cleanup();
   return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
int start2() 
{
  int Zoom = ChartScaleGet(0);
 
  if (Zoom == 5) { LineStartIndex =  5 ; Text_Shift =  -5; }
  else
  if (Zoom == 4) { LineStartIndex = 10 ; Text_Shift = -10; }
  else
  if (Zoom == 3) { LineStartIndex = 15 ; Text_Shift = -15; }
  else
  if (Zoom == 2) { LineStartIndex = 25 ; Text_Shift = -25; }
  else
  if (Zoom == 1) { LineStartIndex = 50 ; Text_Shift = -50; }
  else
  if (Zoom == 0) { LineStartIndex = 100; Text_Shift = -100; }   
  
   if  (Symbol() != "XAUUSD") 
   {
     if (Grid2 && !Grid1) FDrawHorizontalLines1();
     if (Grid1 && !Grid2) FDrawHorizontalLines2();
   }


   return (0);
}
//+------------------------------------------------------------------------------------------------------------------+
void cleanup() 
{
   ObjectDelete("GridLine1");
   ObjectDelete("GridLine2");
   ObjectDelete("GridLine3");
   ObjectDelete("GridLine4");
   ObjectDelete("GridLine5");
   ObjectDelete("GridLine6");
   ObjectDelete("GridLine7");
   ObjectDelete("GridLine8");
   ObjectDelete("GridLine9");
   ObjectDelete("GridLine10");
   ObjectDelete("GridLine11");
   
   ObjectDelete("GridLabel1");
   ObjectDelete("GridLabel2");
   ObjectDelete("GridLabel3");
   ObjectDelete("GridLabel4");
   ObjectDelete("GridLabel5");
   ObjectDelete("GridLabel6");
   ObjectDelete("GridLabel7");
   ObjectDelete("GridLabel8");
   ObjectDelete("GridLabel9");
   ObjectDelete("GridLabel10");
   ObjectDelete("GridLabel11");

}

void FDrawHorizontalLines1() 
{
   if (LineStartIndex < 1) LineStartIndex = 1;
   gridd[1] = HLine1;
   gridd[2] = HLine2;
   gridd[3] = HLine3;
   gridd[4] = HLine4;
   gridd[5] = HLine5;
   gridz = Close[0];
   
   gridx = gridz / Ndigits / 100.0;
   for (gridy = 1; gridy < 6; gridy++) 
   {
      gridt = NormalizeDouble((100 * gridx + gridd[gridy]) * Ndigits, 4);
      FDrawHorizontalLine(StringConcatenate("GridLine", gridy), gridt, Line_Color_1, Line_Style_1, Line_Width_1, LineStartIndex);
      if (Show_Texts == TRUE) 
        FDrawLabel1(StringConcatenate("GridLabel", gridy), DoubleToStr(gridt, Ndecimais), gridt, Text_Color);
   }
}

void FDrawHorizontalLines2() 
{
   if (LineStartIndex < 1) LineStartIndex = 1;
   
   gridd[1] = HLine1_2;
   gridd[2] = HLine2_2;
   gridd[3] = HLine3_2;
   gridd[4] = HLine4_2;
   gridd[5] = HLine5_2;
   gridd[6] = HLine6_2;
   gridd[7] = HLine7_2;
   gridd[8] = HLine8_2;
   gridd[9] = HLine9_2;
   gridd[10]= HLine10_2;
   gridd[11]= HLine11_2;
   
   gridz = Close[0];
   
   gridx = gridz / Ndigits / 100.0;

   
   for (gridy = 1; gridy < 12; gridy++) 
   {
      gridt = NormalizeDouble((100 * gridx + gridd[gridy]) * Ndigits, 4);

      if (gridy==1 || gridy==11)  
          FDrawHorizontalLine(StringConcatenate("GridLine", gridy), gridt, Line_Color00,     Line_Style, Line_Width, LineStartIndex);      
      else
      if (gridy==6)  
          FDrawHorizontalLine(StringConcatenate("GridLine", gridy), gridt, Line_MedianColor, Line_Style, Line_Width, LineStartIndex); 
      else
          FDrawHorizontalLine(StringConcatenate("GridLine", gridy), gridt, Line_Color,       Line_Style, Line_Width, LineStartIndex);      


      if (gridy==1 ||  gridy==11)  
         FDrawLabel2(StringConcatenate("GridLabel", gridy), DoubleToStr(gridt, Ndecimais), gridt, Text_Color00);
      else 
      if (gridy==6)
         FDrawLabel2(StringConcatenate("GridLabel", gridy), DoubleToStr(gridt, Ndecimais), gridt, Text_MedianColor);              
      else
         FDrawLabel2(StringConcatenate("GridLabel", gridy), DoubleToStr(gridt, Ndecimais), gridt, Text_Color);          
   }
}

void FDrawLabel1(string name1, string text1, double price1, color color1) 
{
   if (ObjectFind(name1) != 0) 
   {
      if (Text_Shift >= 0) 
        ObjectCreate(name1, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_Shift * Period()), price1);
      else 
        ObjectCreate(name1, OBJ_TEXT, 0, Time[-Text_Shift], price1);
      
      ObjectSetText(name1, text1, Text_Size, FontType, CLR_NONE);
      ObjectSet(name1, OBJPROP_COLOR, color1);
      ObjectSet(name1, OBJPROP_HIDDEN, true);
      ObjectSet(name1, OBJPROP_SELECTABLE, false);
      
      return;
   }
   
   ObjectDelete(name1);
   if (Text_Shift >= 0) 
     ObjectCreate(name1, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_Shift * Period()), price1);
   else 
     ObjectCreate(name1, OBJ_TEXT, 0, Time[-Text_Shift], price1);
   
   ObjectSetText(name1, text1, Text_Size, FontType, CLR_NONE);
   ObjectSet(name1, OBJPROP_COLOR, color1);
   ObjectSet(name1, OBJPROP_HIDDEN, true);
   ObjectSet(name1, OBJPROP_SELECTABLE, false);
}

void FDrawLabel2(string name2, string text2, double price2, color color2) 
{
   if (ObjectFind(name2) != 0) 
   {
      if (Text_Shift >= 0) 
        ObjectCreate(name2, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_Shift * Period()), price2);
      else 
        ObjectCreate(name2, OBJ_TEXT, 0, Time[-Text_Shift], price2);
      
      ObjectSetText(name2, text2, Text_Size, FontType, CLR_NONE);
      ObjectSet(name2, OBJPROP_COLOR, color2);
      ObjectSet(name2, OBJPROP_HIDDEN, true);
      ObjectSet(name2, OBJPROP_SELECTABLE, false);      
      return;
   }
   
   ObjectDelete(name2);
   if (Text_Shift >= 0) 
     ObjectCreate(name2, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_Shift * Period()), price2);
   else 
     ObjectCreate(name2, OBJ_TEXT, 0, Time[-Text_Shift], price2);
   
   ObjectSetText(name2, text2, Text_Size, FontType, CLR_NONE);
   ObjectSet(name2, OBJPROP_COLOR, color2);
   ObjectSet(name2, OBJPROP_HIDDEN, true);
   ObjectSet(name2, OBJPROP_SELECTABLE, false); 
}

void FDrawHorizontalLine(string name, double price, color cor, int style, int width, int index) 
{
   if (ObjectFind(name) != 0) 
   {
      ObjectCreate(name, OBJ_TREND, 0, Time[index], price, Time[0], price);
      ObjectSet(name, OBJPROP_HIDDEN, true);
      ObjectSet(name, OBJPROP_STYLE, style);
      ObjectSet(name, OBJPROP_COLOR, cor);
      ObjectSet(name, OBJPROP_WIDTH, width);
      ObjectSet(name, OBJPROP_HIDDEN, true);
      ObjectSet(name, OBJPROP_SELECTABLE, false); 
      return;
   }
   ObjectDelete(name);
   ObjectCreate(name, OBJ_TREND, 0, Time[index], price, Time[0], price);
   ObjectSet(name, OBJPROP_HIDDEN, true);   
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_COLOR, cor);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_HIDDEN, true);
   ObjectSet(name, OBJPROP_SELECTABLE, false);
}

int ChartScaleGet(const long chart_ID=0)
  {

   long result=-1;

   ResetLastError();

   if(!ChartGetInteger(chart_ID,CHART_SCALE,0,result))
     {
     }

   return((int)result);
  }

bool ChartScaleSet(const long value,const long chart_ID=0)
  {

   ResetLastError();

   if(!ChartSetInteger(chart_ID,CHART_SCALE,0,value))
     {
     }

   return(true);
  }
