// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338
//+------------------------------------------------------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------------------------------------------------------+
// not for sale, rent, auction, nor lease
#property indicator_chart_window
#property indicator_buffers 21 //21 Moving Averages
#property indicator_color1  clrGold      // 
#property indicator_color2  clrYellow       // 
#property indicator_color3  clrGold       //
#property indicator_color4  clrOrange       //
#property indicator_color5  clrOrange       //
#property indicator_color6  clrDarkOrange  //
#property indicator_color7  clrDarkOrange   //
#property indicator_color8  clrOrangeRed    //
#property indicator_color9  clrOrangeRed         //
#property indicator_color10 clrRed  //169

#property indicator_color11 clrRed    //
#property indicator_color12 clrFireBrick    //225
#property indicator_color13 clrFireBrick    //
#property indicator_color14 C'155,30,30'  //289
#property indicator_color15 C'155,30,30' //324  
#property indicator_color16 C'126,24,24' //361
#property indicator_color17 C'125,23,23'  //400
#property indicator_color18 C'95,18,18'    //441
#property indicator_color19 C'86,16,16'  //484
#property indicator_color20 C'68,13,13'    //

#property indicator_color21 C'69,14,14'  //576

extern string              MA1                   = "------------------------------";
extern ENUM_MA_METHOD      Method1               = MODE_EMA;
extern ENUM_APPLIED_PRICE  Price1                = PRICE_CLOSE; // Price to use 

//template code start1
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "FIRE";
extern string             btn_Font              = "Impact";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = C'120,120,120';
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                     //btn__x
extern int                button_y              = 13;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             UniqueButtonID        = "FireAndDarkness1";
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
double ExtMapBuffer1[],  ExtMapBuffer2[],  ExtMapBuffer3[],  ExtMapBuffer4[],  ExtMapBuffer5[],  ExtMapBuffer6[],  ExtMapBuffer7[],  ExtMapBuffer8[],  ExtMapBuffer9[],  ExtMapBuffer10[];
double ExtMapBuffer11[], ExtMapBuffer12[], ExtMapBuffer13[], ExtMapBuffer14[], ExtMapBuffer15[], ExtMapBuffer16[], ExtMapBuffer17[], ExtMapBuffer18[], ExtMapBuffer19[], ExtMapBuffer20[];
double ExtMapBuffer21[];
//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything here
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
string buttonId;

int OnInit()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + UniqueButtonID;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexBuffer(3, ExtMapBuffer4);
   SetIndexBuffer(4, ExtMapBuffer5);
   SetIndexBuffer(5, ExtMapBuffer6);
   SetIndexBuffer(6, ExtMapBuffer7);
   SetIndexBuffer(7, ExtMapBuffer8);
   SetIndexBuffer(8, ExtMapBuffer9);
   SetIndexBuffer(9, ExtMapBuffer10);
   
   SetIndexBuffer(10,ExtMapBuffer11);
   SetIndexBuffer(11,ExtMapBuffer12);
   SetIndexBuffer(12,ExtMapBuffer13);
   SetIndexBuffer(13,ExtMapBuffer14);
   SetIndexBuffer(14,ExtMapBuffer15);
   SetIndexBuffer(15,ExtMapBuffer16);
   SetIndexBuffer(16,ExtMapBuffer17);
   SetIndexBuffer(17,ExtMapBuffer18);
   SetIndexBuffer(18,ExtMapBuffer19);
   SetIndexBuffer(19,ExtMapBuffer20);
   SetIndexBuffer(20,ExtMapBuffer21);
   
       for (int banzai=0; banzai<indicator_buffers; banzai++)
           SetIndexStyle(banzai,DRAW_LINE,STYLE_DOT,1);

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

//put deinit() here

	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything here
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything here
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   //put start () here
   int i,limit,counted_bars=IndicatorCounted();  
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(i=0; i<limit; i++){
      int y = iBarShift(NULL,0,Time[i]);

      ExtMapBuffer1[i] =iMA(NULL,0,25, 0,Method1,Price1,i);
      ExtMapBuffer2[i] =iMA(NULL,0,16, 0,Method1,Price1,i);
      ExtMapBuffer3[i] =iMA(NULL,0,36, 0,Method1,Price1,i);
      ExtMapBuffer4[i] =iMA(NULL,0,49, 0,Method1,Price1,i);
      ExtMapBuffer5[i] =iMA(NULL,0,64, 0,Method1,Price1,i);
      ExtMapBuffer6[i] =iMA(NULL,0,81, 0,Method1,Price1,i);
      ExtMapBuffer7[i] =iMA(NULL,0,100, 0,Method1,Price1,i);     
      ExtMapBuffer8[i] =iMA(NULL,0,121, 0,Method1,Price1,i);
      ExtMapBuffer9[i] =iMA(NULL,0,144, 0,Method1,Price1,i);
      ExtMapBuffer10[i]=iMA(NULL,0,169, 0,Method1,Price1,i);
      
      ExtMapBuffer11[i]=iMA(NULL,0,196, 0,Method1,Price1,i);
      ExtMapBuffer12[i]=iMA(NULL,0,225, 0,Method1,Price1,i);
      ExtMapBuffer13[i]=iMA(NULL,0,256, 0,Method1,Price1,i);
      ExtMapBuffer14[i]=iMA(NULL,0,289, 0,Method1,Price1,i);
      ExtMapBuffer15[i]=iMA(NULL,0,324, 0,Method1,Price1,i);
      ExtMapBuffer16[i]=iMA(NULL,0,361, 0,Method1,Price1,i);
      ExtMapBuffer17[i]=iMA(NULL,0,400, 0,Method1,Price1,i);    
      ExtMapBuffer18[i]=iMA(NULL,0,441, 0,Method1,Price1,i);
      ExtMapBuffer19[i]=iMA(NULL,0,484, 0,Method1,Price1,i);
      ExtMapBuffer20[i]=iMA(NULL,0,529, 0,Method1,Price1,i);
      
      ExtMapBuffer21[i]=iMA(NULL,0,576, 0,Method1,Price1,i);
   }
      if (show_data)
         {
         ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
       for (int banzai=0; banzai<indicator_buffers; banzai++)
           SetIndexStyle(banzai,DRAW_LINE);
         }
      else
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
       for (banzai=0; banzai<indicator_buffers; banzai++)
           SetIndexStyle(banzai,DRAW_NONE);
      }
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
