//https://forex-station.com/viewtopic.php?p=1295413347#p1295413347
#property indicator_chart_window
#property indicator_buffers 0
#property strict
// extern string  Symbols       = "AUDCAD;AUDCHF;AUDJPY;AUDNZD;AUDUSD;*;CADCHF;CADJPY;CHFJPY;*;EURAUD;EURCAD;EURCHF;EURGBP;EURJPY;EURNZD;EURUSD;*;GBPAUD;GBPCAD;GBPCHF;GBPJPY;GBPNZD;GBPUSD;*;NZDCAD;NZDCHF;NZDJPY;NZDUSD;*;USDCAD;USDCHF;USDJPY;*;XAUUSD;XAGUSD"; // List of symbols (separated by ";" 
 extern string  Symbols       = "WS30;*;US500;*;NDX100;*;US2000;*;HK50;*;DAX30;*;USOUSD;*;GBPAUD;*;GBPJPY;*;GBPNZD;*;XAUUSD"; 
 // List of symbols (separated by ";" 

extern string          str1             = "";                          // and "*" new line)
extern string          UniqueID         = "SymbolChanger1"; // Indicator unique ID
extern int             WindowIndex      = 0;                // SubWIndow
input ENUM_BASE_CORNER SymCorner        = 1;           // SymCorner
extern int             XShift           = 106;               //  Horizontal shift
extern int             YShift           = 254;               // Vertical shift
extern int             XSize            = 72;               // Width of buttons
extern int             YSize            = 18;               // Height of buttons
extern int             FSize            = 10;                // Font size
extern color           Bcolor           = C'35,35,35';      // Button color
extern color           Dcolor           = clrDimGray;       // Button border color
extern color           Tncolor          = clrSnow;         // Text color - normal
extern color           Sncolor          = clrAqua;           // Text color - selected
extern bool            Transparent      = false;            // Transparent buttons?
extern bool            UseAsMasterChart = true;          // Use this Chart as Master 
extern string          sound            = "tick.wav"; // Play sound on button click
//+------------------------------------------------------------------------------------------------------------------+
extern bool showTFbuttons    = true;
input int     TimButtonsInARow = 1;             // Buttons in a horizontal row
input ENUM_BASE_CORNER TimCorner = 1;           // TimCorner
input int     TimXshift     = 33;               // Horizontal shift of Time buttons
extern int    TimYshift     = 254;              // Vertical shift of Time buttons
input int     TimWidth      = 26;               // Width of Time buttons
input int     TimHeight     = 18;               // Height of Time buttons
input int     TimSize       = 10;               // Font size of Time
input color   Bcolor2        = C'35,35,35';      // Button color
input color   Dcolor2        = clrDimGray;       // Button border color
input color   Tncolor2       = clrSnow;          // Text color - normal
input color   Sncolor2       = clrAqua;          // Text color - selected
extern bool   Transparent2   = false;            // Transparent buttons?
//+------------------------------------------------------------------------------------------------------------------+
string  aSymbols[];
int    yswitch;
bool   visibleButtons=true;
//+------------------------------------------------------------------------------------------------------------------+
int OnInit() 
{
   Symbols = StringTrimLeft(StringTrimRight(Symbols));
   if (StringSubstr(Symbols,StringLen(Symbols)-1,1) != ";")
                    Symbols = StringConcatenate(Symbols,";");
   
         int s=0,i=StringFind(Symbols,";",s);
         string current;
         while (i > 0)
         {
            current = StringSubstr(Symbols,s,i-s);
               ArrayResize(aSymbols,ArraySize(aSymbols)+1);
                           aSymbols[ArraySize(aSymbols)-1] = current;
                           s = i + 1;
                           i = StringFind(Symbols,";",s);
         }
            
   int xpos=0,ypos=0,maxx=0,maxy=0; 
   
          yswitch=YShift+1;       
         createButton1(UniqueID+":master:","v",XShift,yswitch,16,16);
         ObjectSetString(WindowIndex,UniqueID+":master:",OBJPROP_TOOLTIP,"Symbol Changer");
         
         ypos+=YSize+1;
         for (i = 0; i<ArraySize(aSymbols); i++)
            {       
               if (aSymbols[i]=="*") { xpos=0; ypos+=YSize+1;  } else { createButton1(UniqueID+":symbol:"+string(i),aSymbols[i],XShift+xpos,YShift+ypos,XSize,YSize); 
               xpos +=XSize+1;}
            }                     

         xpos = 0; ypos += YSize*2;             
               
   setSymbolButtonColor();
   
   // Set MasterChart
   if (UseAsMasterChart) StoreChartPair();
  
   IndicatorShortName("");

   return(0);   
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason)
{ 
   switch(reason)
   {
      case REASON_CHARTCHANGE :
      case REASON_RECOMPILE   :
      case REASON_CLOSE       : break;
      default :
      {
         string lookFor       = UniqueID+":";
         int    lookForLength = StringLen(lookFor);
         for (int i=ObjectsTotal()-1; i>=0; i--)
         {
               string objectName = ObjectName(i);  if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
         }
      }                  
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void createButton1(string name, string caption, int xpos, int ypos,int xsize,int ysize)
{
   if (ObjectFind(name)!=0)
       ObjectCreate(0,name,OBJ_BUTTON,WindowIndex,0,0,0);
          ObjectSet(name,OBJPROP_CORNER   ,SymCorner);
          ObjectSet(name,OBJPROP_XDISTANCE,xpos);
          ObjectSet(name,OBJPROP_YDISTANCE,ypos);
          ObjectSet(name,OBJPROP_XSIZE,xsize);
          ObjectSet(name,OBJPROP_YSIZE,ysize);
          ObjectSetText(name,caption,FSize,"Arial",Tncolor);
              ObjectSet(name,OBJPROP_FONTSIZE,FSize);
              ObjectSet(name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
              ObjectSet(name,OBJPROP_COLOR,Tncolor); 
              ObjectSet(name,OBJPROP_BGCOLOR,Bcolor); 
              ObjectSet(name,OBJPROP_BACK,Transparent); 
              ObjectSet(name,OBJPROP_BORDER_COLOR,Dcolor); 
              ObjectSet(name,OBJPROP_STATE,false);
              ObjectSet(name,OBJPROP_HIDDEN,true);
}
//+------------------------------------------------------------------------------------------------------------------+
void setSymbolButtonColor()
{
   string lookFor       = UniqueID+":symbol:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);  
      if (StringSubstr(objectName,0,lookForLength) == lookFor)
      {
         string symbol = ObjectGetString(0,objectName,OBJPROP_TEXT);
         if (symbol != _Symbol)
               ObjectSet(objectName,OBJPROP_COLOR,Tncolor); 
         else  ObjectSet(objectName,OBJPROP_COLOR,Sncolor);
      }         
   }
}
//+------------------------------------------------------------------------------------------------------------------+
 void setTimeFrameButtonColor()
{
   string lookFor       = UniqueID+":time:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);  
      if (StringSubstr(objectName,0,lookForLength) == lookFor)
      {
         int time = stringToTimeFrame(ObjectGetString(0,objectName,OBJPROP_TEXT));
         if (time != _Period)
               ObjectSet(objectName,OBJPROP_COLOR,Tncolor); 
         else  ObjectSet(objectName,OBJPROP_COLOR,Sncolor);
      }         
   }
}
//+------------------------------------------------------------------------------------------------------------------+
   string sTfTable[] = {"M1","M5","15","30","H1","H4","D1","W1","MN"};
   int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//+------------------------------------------------------------------------------------------------------------------+
int stringToTimeFrame(string tf)
{
   for (int i=ArraySize(sTfTable)-1; i>=0; i--) 
         if (tf==sTfTable[i]) return(iTfTable[i]);
                              return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
void StoreChartPair()
{
   string n = "SC-"+Symbol();
   varDel("SC-");
   GlobalVariableSet(n,0);
}
//+------------------------------------------------------------------------------------------------------------------+
string varDel(string sVarPrefix)
{
    string text;
    int nVar = GlobalVariablesTotal();
    
    for (int jVar = 0; jVar < nVar; jVar++) {
	string sVarName = GlobalVariableName(jVar);
	int x = StringFind(sVarName, sVarPrefix);
	if (x >= 0) {
	    GlobalVariableDel(sVarName);
	}
    }  
    return(text);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {   
      if (StringFind(sparam,UniqueID+":symbol:",0)==0)          
            ChartSetSymbolPeriod(0,ObjectGetString(0,sparam,OBJPROP_TEXT),_Period);
      if(StringFind(sparam,UniqueID+":time:"  ,0)==0) 
            ChartSetSymbolPeriod(0,_Symbol, stringToTimeFrame(ObjectGetString(0,sparam,OBJPROP_TEXT)));
        
      if (StringFind(sparam,UniqueID+":back:"  ,0)==0) ObjectSet(sparam,OBJPROP_STATE,false);
      if (StringFind(sparam,UniqueID+":master:"  ,0)==0) {hideButtons();visibleButtons= !visibleButtons;}
      if (UseAsMasterChart) StoreChartPair();
      if (sound!="") PlaySound(sound);     
   }
}  
//+------------------------------------------------------------------------------------------------------------------+
int start() { 
   int xpos=0,ypos=0,maxx=0,maxy=0;
   if(showTFbuttons){xpos = 0; ypos = 20;  for(int i = 0; i<ArraySize(sTfTable); i++){
   if(i>0 && MathMod(i,TimButtonsInARow)==0){xpos=0; ypos+=TimHeight+1;}
   createButton2(UniqueID+":time:"+string(i),sTfTable[i],TimXshift+xpos,TimYshift+ypos); xpos+=TimWidth+1;}}
   setSymbolButtonColor();  setTimeFrameButtonColor();
   
   return(0); }
//+------------------------------------------------------------------------------------------------------------------+
void hideButtons()
{
string lookFor       = UniqueID+":";
         int    lookForLength = StringLen(lookFor);
         for (int i=ObjectsTotal()-1; i>=0; i--)
         {
               
               string objectName = ObjectName(i);  
               if (objectName==UniqueID+":master:") continue;
               if (StringSubstr(objectName,0,lookForLength) == lookFor) 
               { 
                  if (visibleButtons) ObjectSetInteger(WindowIndex,objectName,OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
                  else ObjectSetInteger(WindowIndex,objectName,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);               
               }
         }
}
//+------------------------------------------------------------------------------------------------------------------+
   void createButton2(string name,string caption,int xpos,int ypos){
   if(ObjectFind(name)!=0)
    ObjectCreate(name,OBJ_BUTTON,0,0,0);
       ObjectSet(name,OBJPROP_CORNER   ,TimCorner);
       ObjectSet(name,OBJPROP_XDISTANCE,xpos);
       ObjectSet(name,OBJPROP_YDISTANCE,ypos);
       ObjectSet(name,OBJPROP_XSIZE,TimWidth);
       ObjectSet(name,OBJPROP_YSIZE,TimHeight);
   ObjectSetText(name,caption,TimSize,"Arial",Tncolor);
       ObjectSet(name,OBJPROP_FONTSIZE,TimSize);
       ObjectSet(name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
       ObjectSet(name,OBJPROP_COLOR,Tncolor);
       ObjectSet(name,OBJPROP_BGCOLOR,Bcolor);
       ObjectSet(name,OBJPROP_BACK,Transparent);
       ObjectSet(name,OBJPROP_BORDER_COLOR,Dcolor);
       ObjectSet(name,OBJPROP_STATE,false);
       ObjectSet(name,OBJPROP_HIDDEN,true);}
//+------------------------------------------------------------------------------------------------------------------+
